/* This prog will show how early payments against the principal in
   for example, a home mortgage, will accelerate the payment of
   the loan...    Set95

   $Log: mort.c,v $
   Revision 1.6  1996/03/10 16:42:24  set
   More info on output, nicer formating--uses size of window. Uses rounding to
   produce a more 'bank compatible' output. Lumps spare change into last
   payment, rather than, for example, listing a separate payment for $2.05.

   Revision 1.5  1996/02/26 06:01:03  set
   Made output formating nicer.

   Revision 1.4  1996/01/28 08:48:03  set
   Made year start with 1, and added sanity check for runaway loans..

 * Revision 1.3  1995/07/10  15:19:26  set
 * Semi final
 *
*/

#define EOL 10
#define MAXLINE 255
#define MINTOL monthly_payment/10

#include <stdio.h>
#include <stdlib.h>

void dline(int col);
float round(float x);

main(int argc, char **argv) {

float rate, loan_principal, monthly_payment, extra;
float yearly_principal, yearly_interest, total_interest, total_principal;
float current_principal, current_interest;
int col, line, i, j, year, monthly, maxyears;
char *Col, *Line;

  monthly=0; maxyears=1000;

  /* Get some environment variables */
  Col=getenv("COLUMNS"); 
  Line=getenv("LINES");
  if(Col==NULL) col=80;
    else
  col=atoi(Col);
  if(Line==NULL) line=40;
    else
  line=atoi(Line);

  /* Get the basic initial numbers */
  printf("Enter the interest rate (eg. 8.5 for 8.5%): ");
  scanf("%f", &rate);
  rate=rate/100;

  printf("Enter the principal due on the mortgage: ");
  scanf("%f", &loan_principal);

  printf("Enter the monthly payment (not including escrow): ");
  scanf("%f", &monthly_payment);

  printf("Enter the amount you wish to pay toward principal,\n  in addition to your normal monthly payment: ");
  scanf("%f", &extra);

  total_interest=total_principal=0;
  year=0;
  do {
    yearly_interest=yearly_principal=0;

    if(monthly) {
      printf("Month\tInterest\tPrincipal\tLoan balance\n");
    }

    /* Calculate the monthly payments */
    for(i=0; (i<12) ;++i) {
      if(loan_principal <= MINTOL) break;
      current_interest=round(rate*loan_principal/12.0);
      if(loan_principal<=monthly_payment+extra) {
        if(loan_principal<=extra) extra=0;
        current_principal=loan_principal-current_interest;
      } else {
        current_principal=monthly_payment-current_interest+extra;
      }
      if (current_principal < 0) {
        printf("My god! The payment will not even cover the interest.\nThis debt \
                will grow infinitely large. Shoot your banker and/or yourself!\n");
        exit(0);
      }
      yearly_interest+=current_interest;
      yearly_principal+=current_principal;
      loan_principal-= current_principal;

      if(loan_principal < MINTOL) break;
      if(monthly) {
        printf("%d\t%f\t%f\t%f\n", i+1, current_interest, current_principal, loan_principal);
      }
    }
    
    if( i == 12 || loan_principal < MINTOL ) {
      ++year;
      i=0;
    }

/* just tack the penny-ante round off error to the last payment */
    if(loan_principal < MINTOL) {
      yearly_principal+=loan_principal;
      loan_principal=0;
    }

    total_interest+=yearly_interest;
    total_principal+=yearly_principal;
    if(col>80) col=80;
    if(year% (line-3) == 0 || year==1) {
      dline(col);
      printf("Year\tPrincipal\tInterest\tTotal Int.\tTotal Prin.\tBalance\n");
      dline(col);
    }

    printf("%d\t%8.2f\t%8.2f\t%8.2f\t%8.2f\t%8.2f\n", \
	   year, yearly_principal, yearly_interest, total_interest, \
	   total_principal, loan_principal);

  } while((loan_principal>0.009) && (year<maxyears));

}

void dline(int col) {
  int i; 
  for(i=0;i<col;++i) putc('=', stdout);
  putc(EOL, stdout);
}

float round(float x) {
	return (float) (int)((x + 0.005)*100.00) / 100.0;
}
